<%@ Page Language="c#" Codebehind="PostbackAndClose.aspx.cs" AutoEventWireup="false" %>

<%@ Register TagPrefix="radW" Namespace="Telerik.WebControls" Assembly="RadWindow.Net2" %>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" >
<html>
<head>
   <title>rad window that postbacks, and manipulates opener page on its reload</title>
   <link rel="stylesheet" type="text/css" href="./Styles.css" />
</head>
<body>
   <form id="Form1" method="post" runat="server">
      <radW:RadWindowManager ID="Singleton" Height="500px" Width="840px" runat="server">
      </radW:RadWindowManager>

      <script type="text/javascript">
        function OpenSelfClosingRadWindow()
        {
            window.radopen("SelfClosingDialog.aspx", null);
        }

        function TestFunction(radWindowCaller)
        {
            alert("Function TestFunction called from within a RadWindow dialog");
        }
      </script>

      <br />
      <button onclick="OpenSelfClosingRadWindow();return false;" style="width: 150px" type="button">
         Open RadWindow</button>
      <br />
      <br />
      <table class="ConfigTable" height="193" width="672">
         <tr>
            <th>
               Scenario
            </th>
         </tr>
         <tr>
            <td>
               <p>
                  Postback RadWindow, reload and close it on reload (the scenario when regular browser
                  windows calls <strong>self.close()</strong>)<br />
                  <br />
                  Scenario #1 - common when the RadWindow opens a Wizard that will perform some action,
                  such as user registration (with a postback to the server), and then need to close
                  itself automatically without the user explicitly closing it.
                  <br />
                  <br />
                  Scenario #2 - similar to above, reload the parent browser page after a postback,
                  to display the changes (e.g. updated user list, for example).
                  <br />
                  <br />
                  Scenario #3 - redirect the parent browser window to a new page after a postback
                  (e.g. in Wizard scenarios or in login scenarios).
                  <br />
                  <br />
                  Scenario #4 - perform a postback, then call a particular function defined on the
                  parent page (useful in dialog scenarios)
                  <br />
                  <br />
                  <strong>Note</strong>: At present (RadWindow v1.01) reloading the browser page will
                  not automatically make the opened windows to re-appear after the postback, but this
                  will be implemented in the future.
                  <br />
                  <br />
                  <fieldset>
                     <div>
                        Scenario #5 :</div>
                     <br />
                     <br />
                     <div>
                        <label>
                           Do postback by pressing the button bellow:</label>
                        <br />
                        <asp:Button ID="Button1" runat="server" Text="Do PostBack. Then " />
                        <label>
                           Then open RadWindow (by pressing the "Open RadWindow" button).
                           <br />
                           Try to refresh the page by clicking the "Postback page, refresh parent page on reload
                           (by using ScriptManager.RegisterStartupScript)" button. You would get a warning
                           message. If you want to avoid this message, you need to use the last button on the
                           RadWindow's content. In this case a postback occurs without a warning message.
                        </label>
                     </div>
                  </fieldset>
               </p>
            </td>
         </tr>
         <tr>
            <th>
               Self Closing Dialog Code
            </th>
         </tr>
         <tr>
            <td>
               <h3>
                  Only scenarios 1 and 2 are covered in detail below. Scenarios 3 and 4 are very similar,
                  plese review directly the source of the page <b style="color: blue">./SelfClosingDialog.aspx</b>
                  for extra information.</h3>
               1) Include all necessary javascript to the page,e.g. <font color="#0000ff" size="2">
                  &lt;</font><font color="#800000" size="2">script type="text/javascript"</font><font
                     color="#0000ff" size="2">&gt;<br />
                  </font><font color="#008000" size="2">//This code is used to provide a reference to
                     the radwindow "wrapper"<br />
                  </font><font color="#0000ff" size="2">function</font><font size="2"> GetRadWindow()<br />
                     {<br />
                     &nbsp;&nbsp;&nbsp;&nbsp;</font><font color="#0000ff" size="2">var</font><font size="2">
                        oWindow = </font><font color="#0000ff" size="2">null</font><font size="2">;<br />
                           &nbsp;&nbsp;&nbsp;&nbsp;</font><font color="#0000ff" size="2">if</font><font size="2">
                              (window.radWindow) oWindow = window.radWindow; </font><font color="#008000" size="2">
                                 //Will work in FireFox in all cases, including classic dialog<br />
                                 &nbsp;&nbsp;&nbsp;&nbsp;</font><font color="#0000ff" size="2">else</font><font size="2">
                                 </font><font color="#0000ff" size="2">if</font><font size="2"> (window.frameElement.radWindow)
                                    oWindow = window.frameElement.radWindow;</font><font color="#008000" size="2">//IE
                                       (and Moz az well)&nbsp;<br />
                                       &nbsp;&nbsp;&nbsp;&nbsp;</font> oWindow;<br />
               }
               <p>
               </p>
               <font color="#0000ff" size="2">function</font><font size="2"> CloseOnReload()<br />
                  {<br />
                  &nbsp;&nbsp;&nbsp;&nbsp;GetRadWindow().close();<br />
                  }
                  <p>
                  </p>
               </font><font color="#0000ff" size="2">function</font><font size="2"> RefreshParentPage()<br />
                  {<br />
                  &nbsp;&nbsp;&nbsp;&nbsp;GetRadWindow().BrowserWindow.location.reload();<br />
                  }<br />
               </font><font color="#0000ff" size="2">&lt;/</font><font color="#800000" size="2">script</font>
               2) Declare a <strong>asp:Label</strong> within the dialog that will be used as a
               placehoder for injecting the proper client-side function call depending which button
               is clicked.
               <br />
               3) Declare two <strong>asp:Button</strong> objects and assign (server) onclick event
               handlers.
               <br />
               4) In the handlers perform the needed serverside actions and then set proper Text
               value to the <strong>asp:Label</strong> object, e.g. <font color="#0000ff" size="2">
                  <p>
                  private</font><font size="2"> </font><font color="#0000ff" size="2">void</font><font
                     size="2"> Button1_Click(</font><font color="#0000ff" size="2">object</font>
               sender, System.EventArgs e)<br />
               {<br />
               &nbsp;&nbsp;&nbsp;&nbsp;InjectScript.Text="&lt;script&gt;CloseOnReload()&lt;/" +
               "script&gt;";<br />
               } <font color="#0000ff" size="2">private</font><font size="2"> </font><font color="#0000ff"
                  size="2">void</font><font size="2"> Button2_Click(</font><font color="#0000ff" size="2">object</font>
               sender, System.EventArgs e)<br />
               {<br />
               &nbsp;&nbsp;&nbsp;&nbsp;InjectScript.Text="&lt;script&gt;RefreshParentPage()&lt;/"
               + "script&gt;";<br />
               }
            </td>
         </tr>
      </table>
   </form>
</body>
</html>
